-------------------------------------------------------------------------------
-- fast_entity - fast html entity scanner algotithm in eiffel                 -
--                                                                            -
-- Author: Steven Hanley                                                      -
-- Date: 26/04/00                                                             -
-- Last Modified: 26/04/00                                                    -
-------------------------------------------------------------------------------

indexing
   description: "Converts lines with html entities to text"
   author: "Steven Hanley"

class
   
   FAST_ENTITY
      
creation
   
   make
   
feature {NONE} -- Creation
   
   converted: STRING
--   specials: SPECIALS
   
   make is
      local
         in: STRING
      do
--         !!specials.make
         from  until std_input.end_of_input loop
            std_input.read_line
            in := clone (std_input.last_string)
            replace_entities (in)
            io.put_string (converted + "%N")
         end
      end

feature {ANY} -- Commands
   
   replace_entities (in: STRING) is
	 -- Replace character entities in `content' with the actual 
         -- characters referred to.
      local
         outa: STRING
         inlen, inoff, outoff, num, off: INTEGER
      do
         outa := clone ("")
         inlen := in.count
         inoff := 1 -- evil indexing at 1 instead of 0
         outoff := 1
         from  until inoff > inlen loop
            if in.item (inoff) /= '&' then 
             -- If no '&', just copy
               outa.add_last (in.item(inoff))
               inoff := inoff + 1
               outoff := outoff + 1
            elseif inoff = inlen or else in.item (inoff + 1) /= '#' then 
             -- If textual entity or end of line
               outa.add_last (in.item(inoff))
               inoff := inoff + 1
               outoff := outoff + 1               
            else
               num := 0
               off := inoff + 2
               
               -- cant use is_integer and to_integer because they 
               -- rely on is_seperator and ; is not a seperator, alas
               
               -- only handle number entities for now
               from  until off > inlen or not in.item (off).is_digit loop
                  num := (num * 10) + in.item (off).decimal_value
                  off := off + 1
               end
               
               if off <= inlen and then in.item (off) = ';' then
                  outa.add_last (num.to_character)
                  outoff := outoff + 1
                  inoff := off + 1
               else -- Skip if not valid entity
                  outa.add_last (in.item(inoff))
                  inoff := inoff + 1
                  outoff := outoff + 1                  
               end
            end
         end
         converted := outa
      end
   
end -- class FAST_ENTITY

