-------------------------------------------------------------------------------
-- slow_entity - slow html entity scanner algotithm in eiffel                 -
--                                                                            -
-- Author: Steven Hanley                                                      -
-- Date: 24/04/00                                                             -
-- Last Modified: 26/04/00                                                    -
-------------------------------------------------------------------------------

indexing
   description: "Converts lines with html entities to text"
   author: "Steven Hanley"

class
   
   SLOW_ENTITY
      
creation
   
   make
   
feature {NONE} -- Creation
   
   converted: STRING
   specials: SPECIALS
   
   make is
      local
         in: STRING
      do
         !!specials.make
         from  until std_input.end_of_input loop
            std_input.read_line
            in := clone (std_input.last_string)
            replace_entities (in)
            io.put_string (converted + "%N")
         end
      end

feature {ANY} -- Commands
   
   replace_entities (contents: STRING) is
	 -- Replace character entities in `content' with the actual 
         -- characters referred to.
      local
         s, t, u, v: STRING
         pos, i, j: INTEGER
      do
         s := clone ("")
         -- should probably add variants and invariants to the loops below
         from pos := 1 until pos >= contents.count loop
            t := contents.substring (pos, contents.count)
            --io.put_string ("t: " + t + " contents: " + contents + "%N")
            if not t.has ('&') then -- nothimg more to do, get out
               pos := contents.count
               s.append (t)
               --io.put_string ("no ampersand%N")
            else
               -- adjust j for irelevant characters at the start of 
               -- the entity
               u := clone (""); v := clone ("")
               i := t.index_of ('&')
               if i /= 1 then
                  s.append (t.substring (1, i - 1))
               end
               j := i
               u.add_last ('&')
               j := j + 1
               if t.item (j) = '#' then 
                  u.add_last ('#');
                  j := j + 1
               end

               -- read the encoding for the entity
                       from
                 -- nothing
               until 
                  t.item(j) = ';' or else
                  not (t.item(j).is_letter or else t.item(j).is_digit) or else
                  pos + j > contents.count
               loop
                  --io.put_character (t.item(j)); io.put_character (' ')
                  u.add_last (t.item(j))
                  v.add_last (t.item(j))
                  j := j + 1
               end
               
               --io.put_string ("i: " + i.to_string + " j: " + j.to_string + 
               --               " s: " + s + " u: " + u + " v: " + v + "%N")
               
               -- v now contains the string that can be translated by specials
               -- either a number or a string of letters, it doesnt matter
               -- u contains the original string including & # but 
               -- not the ;, see next comment for reason
               if t.item(j) = ';' and not v.is_empty then
                  specials.convert (v)
                  if specials.success then
                     s.add_last (specials.character)
                  else
                     s.append (u + ";")
                  end
               else
                  -- correct for the the extra character viewed, it 
                  -- may be part of the next character entity if it 
                  -- wasnt a ;
                  j := j - 1
                  s.append (u)
               end
               
               pos := pos + j
               --io.put_string ("pos: " + pos.to_string + " s: " + s + "%N")
            end
         end
         converted := s
      end
   
end -- class SLOW_ENTITY
